#include "message.h"
#include "data.h"
#include "profile.h"

void wl_award_logic(WL_PROFILE * profile, int award)
{
	int c, i, j;
	
	if(!(profile->awards & award))
	{
		switch(award)
		{
			case WL_PROFILE_AWARD_WIN:
			{
				if(!wl_demo && wl_game.finished)
				{
					profile->awards |= WL_PROFILE_AWARD_WIN;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Enlightened Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_MARATHON:
			{
				if(!wl_demo && wl_game.finished && wl_game.player[0].start_level == 1)
				{
					profile->awards |= WL_PROFILE_AWARD_MARATHON;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Marathon Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_HUNDRED:
			{
				if(wl_game.player[0].word_list_count >= 100)
				{
					profile->awards |= WL_PROFILE_AWARD_HUNDRED;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Hundred Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_DEDICATION:
			{
				if(profile->games >= 100)
				{
					profile->awards |= WL_PROFILE_AWARD_DEDICATION;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Dedication Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_STRIDE:
			{
				if(wl_game.player[0].words_this_level >= 30)
				{
					profile->awards |= WL_PROFILE_AWARD_STRIDE;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Stride Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_QUICKIE:
			{
				if(wl_game.player[0].words_this_level < 10)
				{
					profile->awards |= WL_PROFILE_AWARD_QUICKIE;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Quickie Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			
			/* check this just after grabbing the @ in puzzle mode */
			case WL_PROFILE_AWARD_ALL_CLEAR:
			{
				c = 1;
				if(strlen(wl_game.player[0].word) <= 0)
				{
					for(i = 0; i < WL_MAX_BOARD_HEIGHT; i++)
					{
						for(j = 0; j < WL_MAX_BOARD_WIDTH; j++)
						{
							if(wl_game.board[i][j].letter != ' ')
							{
								c = 0;
							}
						}
					}
					if(c)
					{
						profile->awards |= WL_PROFILE_AWARD_ALL_CLEAR;
						wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "All Clear Award", wl_font[WL_FONT_24], 0);
					}
				}
				break;
			}
			
			/* check when game ends */
			case WL_PROFILE_AWARD_LOSER:
			{
				if(wl_game.player[0].word_list_count <= 0)
				{
					profile->awards |= WL_PROFILE_AWARD_LOSER;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Loser Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_BIG_FAN:
			{
				c = 0;
				
				for(i = 0; i < wl_game.player[0].word_list_count; i++)
				{
					if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "FOOD"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "BOY"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "BURGER"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "KING"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "GUARD"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "DOG"))
					{
						c++;
					}
				}
				if(c >= 6)
				{
					profile->awards |= WL_PROFILE_AWARD_BIG_FAN;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Big Fan Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
			case WL_PROFILE_AWARD_FOUL:
			{
				c = 0;
				
				for(i = 0; i < wl_game.player[0].word_list_count; i++)
				{
					if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "FUCK"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "SHIT"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "DAMN"))
					{
						c++;
					}
					else if(!strcasecmp(wl_dictionary->word[wl_game.player[0].word_list[i]].data, "HELL"))
					{
						c++;
					}
				}
				if(c >= 4)
				{
					profile->awards |= WL_PROFILE_AWARD_FOUL;
					wl_add_message(&wl_award_messages, WL_MESSAGE_TYPE_POPUP, "Foul Mouth Award", wl_font[WL_FONT_24], 0);
				}
				break;
			}
		}
	}
}
