#ifndef WL_BOARD_H
#define WL_BOARD_H

#include "t3f/t3f.h"

#define WL_BOARD_FLAG_POWERUP 4
#define WL_BOARD_FLAG_HAZARD  8
#define WL_BOARD_FLAG_BLOCKED 16

typedef struct
{
	
	char letter;
	int type;
	ALLEGRO_COLOR color;
	bool used;
	int flags;
	
} WL_BOARD_TILE;

void wl_clear_board_flags(void);
void wl_board_logic(void);
void wl_board_render(void);
char wl_board_generate_letter(bool allow_powerups);
void wl_board_generate_powerup_sprite(int i, int j, int letter);
void wl_board_generate_new_letters(void);
void wl_board_regenerate(void);
void wl_add_board_particle(ALLEGRO_COLOR color, int x, int y, int life);
void wl_board_generate_particles(ALLEGRO_COLOR color, int x, int y, int r);

#endif
