#include "data.h"
#include "credits.h"
#include "text.h"

static void wl_add_credit(WL_CREDITS * cp, const char * name, ALLEGRO_FONT * font, ALLEGRO_COLOR color, float y)
{
	if(cp->credits < WL_MAX_CREDITS)
	{
		strcpy(cp->credit[cp->credits].name, name);
		cp->credit[cp->credits].font = font;
		cp->credit[cp->credits].color = color;
		cp->credit[cp->credits].y = y;
		cp->credits++;
	}
}

void wl_credits_initialize(WL_CREDITS * cp, int mode)
{
	float oy = 0.0;
	float small_space = 36.0;
	float big_space = 128.0;
	ALLEGRO_COLOR title_color = al_map_rgba_f(0.2, 1.0, 0.2, 1.0);
	ALLEGRO_COLOR name_color = al_map_rgba_f(1.0, 1.0, 1.0, 1.0);
	
	cp->credits = 0;
	cp->done = false;
	cp->y = 480.0;
	
	wl_add_credit(cp, "Producer", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;
	
	wl_add_credit(cp, "Game Design", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;
	
	wl_add_credit(cp, "Programming", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Level Art", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Story", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Cinema Art", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Cinema Storyboard", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Cinema Programming", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Additional Graphics", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Sound", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Music", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Grady O'Connell", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Lowell J. Stevens", wl_font[WL_FONT_32], name_color, oy);
	oy += big_space;

	wl_add_credit(cp, "Testing", wl_font[WL_FONT_32], title_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Todd Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Travis Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Terry Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Candace Cope", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Kathy Hancock", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Jason Hale", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Ryan Gumbs", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Dizzy Egg", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "taron", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Matthew Leverton", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Grady O'Connell", wl_font[WL_FONT_32], name_color, oy);
	oy += small_space;
	wl_add_credit(cp, "Cameron Priest", wl_font[WL_FONT_32], name_color, oy);
	oy += 480;
	
	if(mode == 1)
	{
		wl_add_credit(cp, "You Are Truly", wl_font[WL_FONT_32], name_color, oy);
		oy += small_space;
		wl_add_credit(cp, "Enlightened!", wl_font[WL_FONT_32], name_color, oy);
	}
}

void wl_credits_logic(WL_CREDITS * cp)
{
	cp->y -= 1.0;
	if(cp->y + cp->credit[cp->credits - 1].y < -40.0)
	{
		cp->done = true;
	}
}

void wl_credits_render(WL_CREDITS * cp)
{
	int i;
	
	for(i = 0; i < cp->credits; i++)
	{
		if(cp->y + cp->credit[i].y >= -32 && cp->y + cp->credit[i].y < 480)
		{
			wl_draw_text(cp->credit[i].font, cp->credit[i].color, t3f_color_black, al_map_rgba_f(0.0, 0.0, 0.0, 0.5), 320, cp->y + cp->credit[i].y, 4, 4, WL_TEXT_FLAG_CENTER | WL_TEXT_FLAG_OUTLINE | WL_TEXT_FLAG_SHADOW, cp->credit[i].name);
		}
	}
}
