#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "t3f/gui.h"
#include "t3f/font.h"
#include "t3net/t3net.h"
#include "t3net/leaderboard.h"
#include "defines.h"
#include "profile.h"
#include "dictionary.h"
#include "shape.h"
#include "level.h"
#include "title.h"
#include "game.h"
#include "message.h"
#include "cinema.h"
#include "leaderboards.h"
#include "credits.h"

float wl_letter_probability[26] =
{
	8.2, 1.5, 2.8, 4.3, 12.7, 2.2, 2.0, 6.1, 7.0, 0.1, 0.8, 4.0, 2.4,
	6.7, 7.5, 1.9, 0.1,  6.0, 6.3, 9.1, 2.8, 1.0, 2.4, 0.2, 2.0, 0.1
};

int wl_hazard_time[10] =
{
	30, 28, 26, 24, 22, 20, 18, 16, 14, 10
};

float wl_life_chart[] = {1.8, 2.0, 2.2, 2.4, 2.6, 2.8, 3.2, 3.4, 3.6, 3.8, 4.0};

ALLEGRO_BITMAP * wl_bitmap[WL_MAX_BITMAPS] = {NULL};
T3F_ANIMATION * wl_animation[WL_MAX_ANIMATIONS] = {NULL};
ALLEGRO_FONT * wl_font[WL_MAX_FONTS] = {NULL};
T3F_FONT * wl_ascii_font = NULL;
ALLEGRO_SAMPLE * wl_sample[WL_MAX_SAMPLES] = {NULL};
T3F_ATLAS * wl_atlas[WL_MAX_ATLASES] = {NULL};

WL_DICTIONARY * wl_dictionary = NULL;
unsigned long wl_dictionary_checksum = 0;
WL_LEVEL wl_level[2];
int wl_state = WL_STATE_TITLE;
int wl_exit_state = 0;
int wl_pause_state = 0;
int wl_tick = 0;
int wl_tally_tick = 0;
bool wl_demo = false;
WL_GAME wl_game;
WL_SHAPE wl_fg_shape[WL_MAX_SHAPES];
int wl_current_fg_shape = 0;
WL_SHAPE wl_bg_shape[WL_MAX_SHAPES];
int wl_current_bg_shape = 0;
WL_MESSAGES wl_game_messages;
WL_MESSAGES wl_award_messages;
WL_MESSAGES wl_word_messages;
int wl_option[WL_MAX_OPTIONS] = {0};
bool wl_mouse_off = false;
WL_CREDITS wl_credits;
bool wl_mouse_clicked = false;
int wl_end_level = 10;
T3F_RNG_STATE wl_rng_state;

T3F_GUI * wl_menu[WL_MAX_MENUS] = {NULL};
int wl_current_menu = WL_MENU_MAIN;
int wl_last_menu = WL_MENU_MAIN;
int wl_last_item = -1;
char wl_menu_text[256] = {0};
ALLEGRO_USTR * wl_menu_ustr = NULL;
char wl_menu_ustr_buffer[256] = {0};
char wl_copyright_message[256] = {0};

WL_PROFILES * wl_profiles = NULL;

WL_CINEMA * wl_cinema = NULL;
int wl_ending_state = 0;

ALLEGRO_EVENT_QUEUE * wl_async_queue = NULL;
ALLEGRO_EVENT_SOURCE wl_async_source;
T3NET_LEADERBOARD * wl_leaderboard = NULL;
int wl_leaderboard_mode = 0;
int wl_leaderboard_type = 0;
int wl_leaderboard_spot = -1;
int wl_leaderboard_style = 0;

/* tutorial */
int wl_tutorial_step = 0;
int wl_overlay_state;
