#ifndef WL_DATA_H
#define WL_DATA_H

#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "t3f/gui.h"
#include "t3f/font.h"
#include "t3f/rng.h"
#include "t3net/t3net.h"
#include "t3net/leaderboard.h"
#include "defines.h"
#include "profile.h"
#include "dictionary.h"
#include "shape.h"
#include "level.h"
#include "title.h"
#include "game.h"
#include "message.h"
#include "cinema.h"
#include "leaderboards.h"
#include "credits.h"

extern float wl_letter_probability[26];
extern int wl_hazard_time[10];
extern float wl_life_chart[];

extern ALLEGRO_BITMAP * wl_bitmap[WL_MAX_BITMAPS];
extern T3F_ANIMATION * wl_animation[WL_MAX_ANIMATIONS];
extern ALLEGRO_FONT * wl_font[WL_MAX_FONTS];
extern T3F_FONT * wl_ascii_font;
extern ALLEGRO_SAMPLE * wl_sample[WL_MAX_SAMPLES];
extern T3F_ATLAS * wl_atlas[WL_MAX_ATLASES];

extern WL_DICTIONARY * wl_dictionary;
extern unsigned long wl_dictionary_checksum;
extern WL_LEVEL wl_level[2];
extern int wl_state;
extern int wl_exit_state;
extern int wl_pause_state;
extern int wl_tick;
extern int wl_tally_tick;
extern bool wl_demo;
extern WL_GAME wl_game;
extern WL_SHAPE wl_fg_shape[WL_MAX_SHAPES];
extern int wl_current_fg_shape;
extern WL_SHAPE wl_bg_shape[WL_MAX_SHAPES];
extern int wl_current_bg_shape;
extern WL_MESSAGES wl_game_messages;
extern WL_MESSAGES wl_award_messages;
extern WL_MESSAGES wl_word_messages;
extern int wl_option[WL_MAX_OPTIONS];
extern bool wl_mouse_off;
extern WL_CREDITS wl_credits;
extern bool wl_mouse_clicked;
extern int wl_end_level;
extern T3F_RNG_STATE wl_rng_state;

extern T3F_GUI * wl_menu[WL_MAX_MENUS];
extern int wl_current_menu;
extern int wl_last_menu;
extern int wl_last_item;
extern char wl_menu_text[256];
extern ALLEGRO_USTR * wl_menu_ustr;
extern char wl_menu_ustr_buffer[256];
extern char wl_copyright_message[256];

extern WL_PROFILES * wl_profiles;

extern WL_CINEMA * wl_cinema;
extern int wl_ending_state;

extern ALLEGRO_EVENT_QUEUE * wl_async_queue;
extern ALLEGRO_EVENT_SOURCE wl_async_source;
extern T3NET_LEADERBOARD * wl_leaderboard;
extern int wl_leaderboard_mode;
extern int wl_leaderboard_type;
extern int wl_leaderboard_spot;
extern int wl_leaderboard_style;

extern int wl_tutorial_step;
extern int wl_overlay_state;

#endif
