#ifndef WL_DEFINES_H
#define WL_DEFINES_H

#define WL_MAX_WORD_SIZE     256
#define WL_MAX_BOARD_WIDTH    7
#define WL_MAX_BOARD_HEIGHT   7
#define WL_BOARD_CENTER_X (WL_MAX_BOARD_WIDTH / 2)
#define WL_BOARD_CENTER_Y (WL_MAX_BOARD_HEIGHT / 2)
#define WL_BOARD_TILE_SIZE   48
#define WL_BOARD_SIZE_X       (WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE)
#define WL_BOARD_SIZE_Y       (WL_MAX_BOARD_HEIGHT * WL_BOARD_TILE_SIZE)
#define WL_MAX_WORDS        1024
#define WL_MAX_WORD_LIST       6
#define WL_MAX_TOP_WORDS       6 // add one more for the one scrolling off
#define WL_MAX_LIFE        100.0
//#define WL_LIFE_DEPLETE_RATE (WL_MAX_LIFE / 7200.0) // deplete life in one minute of no activity
#define WL_LIFE_DEPLETE_RATE 0.0
#define WL_LEVEL_UP          150
#define WL_MAX_LEVELS         10
#define WL_BOARD_X            ((480 - (WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE)) / 2)
#define WL_BOARD_Y            ((480 - (WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE)) / 2)
#define WL_LIFE_BAR_X         (WL_BOARD_X / 2 - al_get_bitmap_width(wl_bitmap[WL_BITMAP_LIFE]) / 2)
#define WL_LIFE_BAR_Y         WL_BOARD_Y
#define WL_LEVEL_FADE_FRAMES 240.0
#define WL_GAME_MODE_STORY     0
#define WL_GAME_MODE_CASUAL    1
#define WL_GAME_MODE_PUZZLE    2
#define WL_GAME_MODE_GURU      3
#define WL_GAME_MODE_MUSIC     4
#define WL_GAME_MODE_PARTY     5
#define WL_GAME_MODE_SOCIAL    6

#define WL_SPRITE_SWOOSH_HEIGHT -280.0

#define WL_MAX_OPTIONS        64

#define WL_MAX_PLAYERS        16
#define WL_PLAYER_STATE_NORMAL 0
#define WL_PLAYER_STATE_JUMP   1
#define WL_PLAYER_STATE_ENTER  2
#define WL_PLAYER_STATE_EXIT   3
#define WL_PLAYER_SPRITE_STATE_NORMAL 0
#define WL_PLAYER_SPRITE_STATE_HURT   1
#define WL_PLAYER_SPRITE_STATE_HAPPY  2
#define WL_PLAYER_SPRITE_STATE_SAD    3
#define WL_PLAYER_SPRITE_STATE_UP     4
#define WL_PLAYER_SPRITE_STATE_DOWN   5
#define WL_PLAYER_SPRITE_STATE_LEFT   6
#define WL_PLAYER_SPRITE_STATE_RIGHT  7

#define WL_MAX_PARTICLES     512

#define WL_POWERUP_COUNT       30
#define WL_POWERUP_VARY        10
#define WL_POWERUP_GURU         1
#define WL_POWERUP_LIFE         2
#define WL_POWERUP_HOURGLASS   16
#define WL_MAX_POWERUPS        32

#define WL_MAX_BITMAPS         64
#define WL_BITMAP_LIFE          0
#define WL_BITMAP_LEVEL         1
#define WL_BITMAP_LEVEL_FILL    2
#define WL_BITMAP_LIFE_FILL     3
#define WL_BITMAP_LIFE_OVERLAY  4
#define WL_BITMAP_TILE          5
#define WL_BITMAP_POPUP         7
#define WL_BITMAP_SCRATCH       8

#define WL_MAX_ANIMATIONS                   64
#define WL_ANIMATION_PARTICLE                1
#define WL_ANIMATION_PLAYER_SHADOW           2
#define WL_ANIMATION_PARTICLE_2              3
#define WL_ANIMATION_GURU                    4
#define WL_ANIMATION_BOMB                    5
#define WL_ANIMATION_LASER                   6
#define WL_ANIMATION_POWER_HEALTH            7
#define WL_ANIMATION_SPIKE                   8
#define WL_ANIMATION_SELECTOR                9
#define WL_ANIMATION_POWER_GURU             10
#define WL_ANIMATION_PARTICLE_3             11
#define WL_ANIMATION_SPIKE_2                12
#define WL_ANIMATION_PLAYER_NORMAL          13
#define WL_ANIMATION_PLAYER_HAPPY           14
#define WL_ANIMATION_PLAYER_SAD             15
#define WL_ANIMATION_PLAYER_HURT            16
#define WL_ANIMATION_PLAYER_UP              17
#define WL_ANIMATION_PLAYER_DOWN            18
#define WL_ANIMATION_PLAYER_LEFT            19
#define WL_ANIMATION_PLAYER_RIGHT           20
#define WL_ANIMATION_BOMB_SHADOW            21
#define WL_ANIMATION_LASER_SHADOW           22
#define WL_ANIMATION_POWER_HEALTH_SHADOW    23
#define WL_ANIMATION_SPIKE_SHADOW           24
#define WL_ANIMATION_POWER_GURU_SHADOW      25
#define WL_ANIMATION_POWER_HOURGLASS        26
#define WL_ANIMATION_POWER_HOURGLASS_SHADOW 27
#define WL_ANIMATION_PARTICLE_4             28

#define WL_MAX_ATLASES                       2
#define WL_ATLAS_GAME                        0
#define WL_ATLAS_HUD                         1

#define WL_MAX_FONTS          16
#define WL_FONT_24             0
#define WL_FONT_16             1
#define WL_FONT_32             2
#define WL_FONT_12             3

#define WL_MAX_SAMPLES        32
#define WL_SAMPLE_JUMP         0
#define WL_SAMPLE_LAND         1
#define WL_SAMPLE_BAD_WORD     2
#define WL_SAMPLE_WORD         3
#define WL_SAMPLE_GOOD_WORD    4
#define WL_SAMPLE_GREAT_WORD   5
#define WL_SAMPLE_AMAZING_WORD 6
#define WL_SAMPLE_SHATTER      7
#define WL_SAMPLE_BOMB         8
#define WL_SAMPLE_SPIKE        9
#define WL_SAMPLE_LASER       10
#define WL_SAMPLE_LIFE_UP     11
#define WL_SAMPLE_LIFE_LOW    12
#define WL_SAMPLE_GURU        13
#define WL_SAMPLE_HOURGLASS   14
#define WL_SAMPLE_SWOOSH      15
#define WL_SAMPLE_HURT        16
#define WL_SAMPLE_DESTROY     17
#define WL_SAMPLE_BEST_WORD   20
#define WL_SAMPLE_FREEZE      21
#define WL_SAMPLE_THAW        22

#define WL_MAX_VERTICES        6
#define WL_MAX_SHAPES         32

#define WL_STATE_INTRO         0
#define WL_STATE_TITLE         1
#define WL_STATE_GAME          2
#define WL_STATE_GAME_OVER     3
#define WL_STATE_LEADERBOARDS  4
#define WL_STATE_TITLE_EXIT    5
#define WL_STATE_GAME_INTRO    6
#define WL_STATE_GAME_OVER_WAIT 7
#define WL_STATE_TITLE_CREDITS  8
#define WL_STATE_GAME_PAUSED   10
#define WL_STATE_GAME_CONTINUE 11
#define WL_STATE_GAME_QUIT     12
#define WL_STATE_GAME_WIN      13
#define WL_STATE_TO_GAME       14
#define WL_STATE_GAME_EXIT     15
#define WL_STATE_GAME_TALLY    16
#define WL_STATE_GAME_DONE     17
#define WL_STATE_GAME_PAUSED_2 18
#define WL_STATE_GAME_TUTORIAL 19
#define WL_STATE_PAUSED        20
#define WL_STATE_MUSIC         21
#define WL_STATE_MUSIC_QUIT    22
#define WL_STATE_DEMO_WIN      23
#define WL_STATE_PRIVACY       24

#define WL_MAX_SPRITES               64
#define WL_SPRITE_TYPE_PLAYER         0
#define WL_SPRITE_TYPE_BOMB           1
#define WL_SPRITE_TYPE_LASER          2
#define WL_SPRITE_TYPE_POWERUP_HEALTH 3
#define WL_SPRITE_TYPE_POWERUP_GURU   4
#define WL_SPRITE_TYPE_POWERUP_SNEAKER 5
//#define WL_SPRITE_TYPE_POWERUP_3X     6
#define WL_SPRITE_TYPE_SPIKE          7
#define WL_SPRITE_TYPE_100            8

#define WL_SPRITE_Y_OFFSET         -8.0

#define WL_MAX_CREDITS              256
#define WL_TEXT_FLAG_CENTER           1
#define WL_TEXT_FLAG_SHADOW           2
#define WL_TEXT_FLAG_OUTLINE          4

#define WL_OPTION_CONTROLS            0
#define WL_OPTION_MUSIC_VOLUME        1
#define WL_OPTION_SOUND_VOLUME        2
#define WL_OPTION_INTERNET            3
	#define WL_INTERNET_AUTO   0
	#define WL_INTERNET_ASK    1
	#define WL_INTERNET_MANUAL 2
#define WL_OPTION_FIRST_RUN           4
#define WL_OPTION_VIDEO_MODE          5
#define WL_OPTION_LOWRES              6

#define WL_VIDEO_MODE_SMALL_WINDOW      0
#define WL_VIDEO_MODE_MEDIUM_WINDOW     1
#define WL_VIDEO_MODE_LARGE_WINDOW      2
#define WL_VIDEO_MODE_RESIZEABLE_WINDOW 3
#define WL_VIDEO_MODE_FULL_SCREEN       4

#define WL_GRAVITY                  0.5
#define WL_TERMINAL_VELOCITY       14.0

#endif
