#include "t3f/t3f.h"

static ALLEGRO_COLOR wl_fade_start_color;
static ALLEGRO_COLOR wl_fade_end_color;
static ALLEGRO_COLOR wl_fade_current_color;
static int wl_fade_time;
static int wl_fade_last_tick = 0;
int wl_fade_tick = 0;
bool wl_fading = false;

ALLEGRO_COLOR wl_fade_color(ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, float amount)
{
	float r1, g1, b1, a1;
	float r2, g2, b2, a2;
	
	al_unmap_rgba_f(c1, &r1, &g1, &b1, &a1);
	al_unmap_rgba_f(c2, &r2, &g2, &b2, &a2);
	return al_map_rgba_f(r1 + (r2 - r1) * amount, g1 + (g2 - g1) * amount, b1 + (b2 - b1) * amount, a1 + (a2 - a1) * amount);
}

ALLEGRO_COLOR wl_darken_color(ALLEGRO_COLOR c1, float amount)
{
	float r1, g1, b1, a1;
	
	al_unmap_rgba_f(c1, &r1, &g1, &b1, &a1);
	return al_map_rgba_f(r1 * amount, g1 * amount, b1 * amount, a1);
}

ALLEGRO_COLOR wl_alpha_color(ALLEGRO_COLOR c1, float alpha)
{
	float r1, g1, b1, a1;
	
	al_unmap_rgba_f(c1, &r1, &g1, &b1, &a1);
	return al_map_rgba_f(r1 * alpha, g1 * alpha, b1 * alpha, a1 * alpha);
}
void wl_fade_to(ALLEGRO_COLOR start_color, ALLEGRO_COLOR end_color, int time)
{
	wl_fade_time = time;
	wl_fade_tick = time;
	wl_fade_start_color = start_color;
	wl_fade_end_color = end_color;
	wl_fading = true;
}

void wl_stop_fade(void)
{
	wl_fade_tick = 0;
	wl_fade_current_color = al_map_rgba_f(0.0, 0.0, 0.0, 0.0);
}

void wl_process_effects(void)
{
	wl_fade_last_tick = wl_fade_tick;
	if(wl_fade_tick > 0)
	{
		wl_fade_tick--;
		if(wl_fade_tick <= 0)
		{
			wl_fading = false;
		}
	}
	if(wl_fade_last_tick != wl_fade_tick)
	{
		wl_fade_current_color = wl_fade_color(wl_fade_start_color, wl_fade_end_color, 1.0 - (float)wl_fade_tick / (float)wl_fade_time);
	}
}

void wl_render_effects(void)
{
	unsigned char r, a;

	al_unmap_rgba(wl_fade_current_color, &r, &r, &r, &a);
	if(a > 0)
	{
		al_draw_filled_rectangle(0.0, 0.0, 640.0, 480.0, wl_fade_current_color);
	}
}
