#include "t3f/t3f.h"
#include "t3f/resource.h"
#include "data.h"
#include "text_entry.h"

void wl_save_config(void)
{
	char buf[256];
	ALLEGRO_CONFIG * cp;
	const ALLEGRO_FILE_INTERFACE * old_interface;
	char fnbuf[1024] = {0};

	old_interface = al_get_new_file_interface();
	al_set_standard_file_interface();

	cp = al_create_config();
	if(cp)
	{
		sprintf(buf, "%d", wl_option[WL_OPTION_CONTROLS]);
		al_set_config_value(cp, NULL, "Controls", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_MUSIC_VOLUME]);
		al_set_config_value(cp, NULL, "Music Volume", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_SOUND_VOLUME]);
		al_set_config_value(cp, NULL, "Sound Volume", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_VIDEO_MODE]);
		al_set_config_value(cp, NULL, "Video Mode", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_INTERNET]);
		al_set_config_value(cp, NULL, "Upload Scores", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_FIRST_RUN]);
		al_set_config_value(cp, NULL, "First Run", buf);
		sprintf(buf, "%d", wl_option[WL_OPTION_LOWRES]);
		al_set_config_value(cp, NULL, "Low Resolution", buf);
		al_save_config_file(t3f_get_filename(t3f_config_path, "wordleap.cfg", fnbuf, 1024), cp);
		al_destroy_config(cp);
	}
	al_set_new_file_interface(old_interface);
}

void wl_free_data(void)
{
	int i;

	if(wl_cinema)
	{
		wl_destroy_cinema(wl_cinema);
	}
	for(i = 0; i < WL_MAX_ANIMATIONS; i++)
	{
		if(wl_animation[i])
		{
			t3f_destroy_animation(wl_animation[i]);
		}
	}
	/* destroy scratch bitmap first so we don't try to destroy it through the resource manager */
	al_destroy_bitmap(wl_bitmap[WL_BITMAP_SCRATCH]);
	wl_bitmap[WL_BITMAP_SCRATCH] = NULL;
	for(i = 0; i < WL_MAX_BITMAPS; i++)
	{
		if(wl_bitmap[i])
		{
			t3f_destroy_resource(wl_bitmap[i]);
		}
	}
	for(i = 0; i < WL_MAX_SAMPLES; i++)
	{
		if(wl_sample[i])
		{
			al_destroy_sample(wl_sample[i]);
		}
	}
	for(i = 0; i < WL_MAX_FONTS; i++)
	{
		if(wl_font[i])
		{
			t3f_destroy_resource(wl_font[i]);
		}
	}
	for(i = 0; i < WL_MAX_ATLASES; i++)
	{
		if(wl_atlas[i])
		{
			t3f_destroy_atlas(wl_atlas[i]);
		}
	}
	wl_destroy_dictionary(wl_dictionary);
	wl_destroy_profiles(wl_profiles);
}

void wl_exit(void)
{
	wl_save_config();
	al_ustr_free(wl_entered_text_ustr);
	wl_free_data();
	wl_title_exit();
	wl_free_leaderboard_data();
}
