#include "t3f/t3f.h"
#include "t3f/sound.h"
#include "t3f/rng.h"
#include "defines.h"
#include "sprite.h"
#include "data.h"

static int wl_hazard_chart[10][10] = 
{
//	{ WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE },
	{ WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_LASER, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_BOMB, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE, WL_SPRITE_TYPE_SPIKE }
};

static int wl_game_add_sprite(void)
{
	int i;
	
	for(i = 0; i < WL_MAX_SPRITES; i++)
	{
		if(!wl_game.sprite[i].active)
		{
			return i;
		}
	}
	return -1;
}

void wl_game_initialize_hazard(WL_SPRITE * sp)
{
	int i, j, r, s, x, y;
	float z;
	int spot[24];
	int spots = 0;
	
	switch(sp->type)
	{
		case WL_SPRITE_TYPE_BOMB:
		{
			for(i = 0; i < 25; i++)
			{
				x = ((wl_game.player[0].x - 2) + (i % 5));
				y = ((wl_game.player[0].y - 2) + (i / 5));
				if(i != 12 && x >= 0 && x < WL_MAX_BOARD_WIDTH && y >= 0 && y < WL_MAX_BOARD_HEIGHT && !wl_game.board[y][x].used)
				{
					spot[spots] = i;
					spots++;
				}
			}
			if(spots > 0)
			{
				r = rand() % spots;
				for(j = r; j < spots - 1; j++)
				{
					spot[j] = spot[j + 1];
				}
				spots--;
				s = wl_game_add_sprite();
				if(s >= 0)
				{
					sp->timer = 300;
					sp->ftick = 0.0;
					sp->tick = 0;
					sp->type = WL_SPRITE_TYPE_BOMB;
					sp->x = ((wl_game.player[0].x - 2) + (spot[r] % 5)) * WL_BOARD_TILE_SIZE;
					sp->y = ((wl_game.player[0].y - 2) + (spot[r] / 5)) * WL_BOARD_TILE_SIZE;
					sp->z = -320 - 24;
					sp->z *= 3;
					sp->cy = 24;
					sp->vz = WL_TERMINAL_VELOCITY;
					sp->state = 0;
					sp->active = true;
				}
			}
			break;
		}
		case WL_SPRITE_TYPE_LASER:
		{
			r = rand() % 4;
			switch(r)
			{
				case 0:
				{
					sp->y = wl_game.player[0].y * WL_BOARD_TILE_SIZE;
					sp->x = -36 - 48 - WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE;
					sp->z = 0.0;
					sp->vx = 4.0;
					sp->vy = 0.0;
					sp->timer = 0;
					sp->state = 0;
					break;
				}
				case 1:
				{
					sp->y = wl_game.player[0].y * WL_BOARD_TILE_SIZE;
					sp->x = WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE + 36 + WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE;
					sp->z = 0.0;
					sp->vx = -4.0;
					sp->vy = 0.0;
					sp->timer = 0;
					sp->state = 0;
					break;
				}
				case 2:
				{
					sp->x = wl_game.player[0].x * WL_BOARD_TILE_SIZE;
					sp->y = -36 - 48 - WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE;
					sp->z = 0.0;
					sp->vy = 4.0;
					sp->vx = 0.0;
					sp->timer = 0;
					sp->state = 1;
					break;
				}
				default:
				{
					sp->x = wl_game.player[0].x * WL_BOARD_TILE_SIZE;
					sp->y = WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE + 36 + WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE;
					sp->z = 0.0;
					sp->vy = -4.0;
					sp->vx = 0.0;
					sp->timer = 0;
					sp->state = 1;
					break;
				}
			}
			sp->flags = 0;
			t3f_play_sample(wl_sample[WL_SAMPLE_LASER], 1.0, t3f_get_sound_position(wl_game.player[0].sprite.x, wl_game.player[0].sprite.y, sp->x, sp->y), 1.0);
			sp->cy = 24;
			sp->active = true;
			break;
		}
		case WL_SPRITE_TYPE_SPIKE:
		{
			z = -320 - 24;
			z *= 3;
			
			/* make list of places we want spikes to be able to drop */
			for(i = 0; i < 25; i++)
			{
				x = ((wl_game.player[0].x - 2) + (i % 5));
				y = ((wl_game.player[0].y - 2) + (i / 5));
				if(i != 12 && x >= 0 && x < WL_MAX_BOARD_WIDTH && y >= 0 && y < WL_MAX_BOARD_HEIGHT && !wl_game.board[y][x].used)
				{
					spot[spots] = i;
					spots++;
				}
			}
			for(i = 0; i < 3; i++)
			{
				if(spots > 0)
				{
					r = rand() % spots;
					s = wl_game_add_sprite();
					if(s >= 0)
					{
						wl_game.sprite[s].type = WL_SPRITE_TYPE_SPIKE;
						wl_game.sprite[s].x = ((wl_game.player[0].x - 2) + (spot[r] % 5)) * WL_BOARD_TILE_SIZE;
						wl_game.sprite[s].y = ((wl_game.player[0].y - 2) + (spot[r] / 5)) * WL_BOARD_TILE_SIZE;
						wl_game.sprite[s].z = z;
						wl_game.sprite[s].cy = 24;
						wl_game.sprite[s].vz = WL_TERMINAL_VELOCITY;
						wl_game.sprite[s].state = 0;
						z -= 8.0;
						wl_game.sprite[s].active = true;
					}
					z += (9 - i) * 16.0;
					for(j = r; j < spots - 1; j++)
					{
						spot[j] = spot[j + 1];
					}
					spots--;
				}
			}
			break;
		}
	}
}

void wl_explode_sprite(WL_SPRITE * sp)
{
	int i, p;
	
	switch(sp->type)
	{
		case WL_SPRITE_TYPE_BOMB:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba_f(0.1, 0.1, 0.1, 1.0), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
		case WL_SPRITE_TYPE_LASER:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba(255, 158, 28, 255), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
		case WL_SPRITE_TYPE_SPIKE:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba_f(0.7, 0.7, 0.7, 1.0), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
		case WL_SPRITE_TYPE_POWERUP_SNEAKER:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba_f(1.0, 1.0, 1.0, 1.0), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
		case WL_SPRITE_TYPE_POWERUP_GURU:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba(255, 255, 80, 197), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
		case WL_SPRITE_TYPE_POWERUP_HEALTH:
		{
			for(i = 0; i < 10; i++)
			{
				p = wl_add_particle(1, WL_PARTICLE_TYPE_SHARD, wl_animation[WL_ANIMATION_PARTICLE_3], al_map_rgba_f(1.0, 1.0, 1.0, 1.0), sp->x + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, sp->y + WL_BOARD_TILE_SIZE / 2.0 + t3f_drand(&wl_rng_state) * 8.0 - 4.0, -8.0, 0, 60, 0);
				wl_particle[1][p].vx = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vy = t3f_drand(&wl_rng_state) * 4.0 - 2.0;
				wl_particle[1][p].vz = -5.0;
			}
			sp->active = false;
			break;
		}
	}
}

void wl_game_hazard_logic(void)
{
	int i;
	
	wl_game.hazard_count--;
	if(wl_game.hazard_count <= 0)
	{
		for(i = 0; i < WL_MAX_SPRITES; i++)
		{
			if(!wl_game.sprite[i].active)
			{
				wl_game.sprite[i].type = wl_hazard_chart[wl_game.player[0].level - 1][rand() % 10];
				wl_game_initialize_hazard(&wl_game.sprite[i]);
				break;
			}
		}
		wl_game.hazard_count = wl_hazard_time[wl_game.player[0].level - 1] * 60 + rand() % 300 - 150;
	}
}
