#include "t3f/t3f.h"
#include "cinema.h"
#include "data.h"
#include "menu_proc.h"
#include "game_sprite.h"

void wl_game_over_logic(void)
{
	int i;
	ALLEGRO_EVENT event;
	
	wl_process_cinema(wl_cinema);
	
	if(wl_cinema->tick >= wl_cinema->length)
	{
		wl_title_process_menu();
	}
	while(!al_event_queue_is_empty(wl_async_queue))
	{
		al_wait_for_event(wl_async_queue, &event);

		/* score upload was attempted, react to incoming event (success, partial success, or failure) */
		if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 's'))
		{
			wl_leaderboard_thread_counter--;
			wl_download_scores();
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 'p'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_UPLOAD_FAILED);
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 'f'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_UPLOAD_FAILED);
		}

		/* leaderboard download was attempted, react to incoming event (success, partial success, or failure) */
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'd', 's'))
		{
			wl_leaderboard_thread_counter--;
			wl_leaderboard_spot = -1;
			if(wl_leaderboard_type == 0)
			{
				for(i = 0; i < wl_leaderboard->entries; i++)
				{
					if(wl_game.player[0].score == (int)(wl_leaderboard->entry[i]->score - 'w' - 'l' - 'e' - 'a' - 'p') / 3 && !strcasecmp(wl_profiles->entry[wl_game.player[0].profile].name, wl_leaderboard->entry[i]->name))
					{
						wl_leaderboard_spot = i;
						break;
					}
				}
			}
			else
			{
				for(i = 0; i < wl_leaderboard->entries; i++)
				{
					if(wl_game.current_best_word == atoi(wl_leaderboard->entry[i]->extra) && !strcasecmp(wl_profiles->entry[wl_game.player[0].profile].name, wl_leaderboard->entry[i]->name))
					{
						wl_leaderboard_spot = i;
						break;
					}
				}
			}
			wl_create_leaderboard_menu(wl_leaderboard_mode, wl_leaderboard_type);
			wl_state = WL_STATE_GAME_OVER;
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'd', 'f'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_DOWNLOAD_FAILED);
		}
	}
}

void wl_game_over_wait_logic(void)
{
	wl_game_over_logic();
}

void wl_game_over_render(void)
{
	wl_render_cinema(wl_cinema);
	if(wl_cinema->tick >= wl_cinema->length)
	{
		wl_title_render_menu();
	}
}

void wl_game_over_wait_render(void)
{
	wl_game_over_render();
}

void wl_game_done_logic(void)
{
	ALLEGRO_EVENT event;
	int i;
	
	if(wl_game.mode == WL_GAME_MODE_STORY)
	{
		wl_process_particles(0);
		wl_title_process_menu();
		wl_title_word_logic();
	}
	else
	{
		/* game logic */
		wl_process_particles(1);
		wl_clear_board_flags();
		wl_game_sprite_logic();
		wl_board_logic();
		wl_game_player_logic();
		wl_game_process_bg();
		
		wl_message_logic(&wl_game_messages, false);
		wl_message_logic(&wl_word_messages, true);
		
		wl_process_particles(0);
		wl_title_process_menu();
	}

	while(!al_event_queue_is_empty(wl_async_queue))
	{
		al_wait_for_event(wl_async_queue, &event);
		
		/* score upload was attempted, react to incoming event (success, partial success, or failure) */
		if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 's'))
		{
			wl_leaderboard_thread_counter--;
			wl_download_scores();
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 'p'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_UPLOAD_FAILED);
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'u', 'f'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_UPLOAD_FAILED);
		}

		/* leaderboard download was attempted, react to incoming event (success, partial success, or failure) */
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'd', 's'))
		{
			wl_leaderboard_thread_counter--;
			wl_leaderboard_spot = -1;
			if(wl_leaderboard_type == 0)
			{
				for(i = 0; i < wl_leaderboard->entries; i++)
				{
					if(wl_game.player[0].score == (int)(wl_leaderboard->entry[i]->score - 'w' - 'l' - 'e' - 'a' - 'p') / 3 && !strcasecmp(wl_profiles->entry[wl_game.player[0].profile].name, wl_leaderboard->entry[i]->name))
					{
						wl_leaderboard_spot = i;
						break;
					}
				}
			}
			else
			{
				for(i = 0; i < wl_leaderboard->entries; i++)
				{
					if(wl_game.current_best_word == atoi(wl_leaderboard->entry[i]->extra) && !strcasecmp(wl_profiles->entry[wl_game.player[0].profile].name, wl_leaderboard->entry[i]->name))
					{
						wl_leaderboard_spot = i;
						break;
					}
				}
			}
			wl_create_leaderboard_menu(wl_leaderboard_mode, wl_leaderboard_type);
			wl_state = WL_STATE_GAME_DONE;
		}
		else if(event.type == ALLEGRO_GET_EVENT_TYPE('t', 'r', 'd', 'f'))
		{
			wl_leaderboard_thread_counter--;
			wl_select_menu(WL_MENU_DOWNLOAD_FAILED);
		}
	}
}

void wl_game_done_render(void)
{
	if(wl_game.mode == WL_GAME_MODE_STORY)
	{
		wl_title_render();
	}
	else
	{
		wl_game_render();
		al_hold_bitmap_drawing(false);
		al_draw_filled_rectangle(0.0, 0.0, 640.0, 480.0, al_map_rgba_f(0.0, 0.0, 0.0, 0.5));
		al_hold_bitmap_drawing(true);
		wl_title_render_menu();
		al_hold_bitmap_drawing(false);
	}
}
