#include "data.h"
#include "defines.h"
#include "game.h"
#include "game_sprite.h"
#include "text.h"
#include "menu_proc.h"
#include "game_tally.h"

void wl_game_tally_score(void)
{
	int i, l;
	char buf[32] = {0};
	
	if(wl_game.mode == WL_GAME_MODE_PUZZLE)
	{
		
		wl_game.current_unused_letters = 0;
		
		/* count letters player has picked up and not used */
		l = strlen(wl_game.player[0].word);
		for(i = 0; i < l; i++)
		{
			if(wl_game.player[0].score < 0)
			{
				wl_game.player[0].score = 0;
			}
			wl_game.current_unused_letters++;
			wl_game.player[0].word[0] = '\0';
		}
		
		/* count letters left on the board */
		for(i = 0; i < WL_MAX_BOARD_WIDTH * WL_MAX_BOARD_HEIGHT; i++)
		{
			l = wl_game.board[i / WL_MAX_BOARD_HEIGHT][i % WL_MAX_BOARD_WIDTH].letter;
			if(l >= 'A' && l <= 'Z')
			{
				wl_game.current_unused_letters++;
			}
		}
		if(wl_game.current_unused_letters)
		{
			sprintf(buf, "Unused Tiles: %d", wl_game.current_unused_letters);
			wl_add_message(&wl_word_messages, WL_MESSAGE_TYPE_FLOAT_UP, buf, wl_ascii_font, 0);
			sprintf(buf, "Penalty: %d", wl_game.current_unused_letters * 100);
			wl_add_message(&wl_word_messages, WL_MESSAGE_TYPE_FLOAT_UP_2, buf, wl_ascii_font, 0);
			wl_game.player[0].score -= wl_game.current_unused_letters * 100;
			if(wl_game.player[0].score < 0)
			{
				wl_game.player[0].score = 0;
			}
		}
	}
}

void wl_game_tally_logic(void)
{
	
	/* game logic */
	wl_process_particles(1);
	wl_clear_board_flags();
	wl_game_sprite_logic();
	wl_board_logic();
	wl_game_player_logic();
	wl_game_process_bg();
	wl_message_logic(&wl_word_messages, true);
	wl_tally_tick--;
	if(wl_tally_tick <= 0)
	{
		wl_game.board[wl_game.player[0].y][wl_game.player[0].x].letter = ' ';
		wl_game.player[0].state = WL_PLAYER_STATE_EXIT;
		switch(wl_game.mode)
		{
			case WL_GAME_MODE_PARTY:
			{
				break;
			}
			default:
			{
				wl_game_update_best_flags();
				if(wl_game.player[0].profile > 0 && wl_option[WL_OPTION_INTERNET] == WL_INTERNET_AUTO && wl_game.player[0].word_list_count > 0)
				{
					wl_state = WL_STATE_GAME_DONE;
					wl_leaderboard_mode = wl_game.mode;
					wl_leaderboard_type = 0;
					wl_leaderboard_style = 1;
					wl_game_upload_scores();
					wl_create_leaderboard_load_menu(wl_leaderboard_mode, wl_leaderboard_type);
					wl_current_menu = WL_MENU_LEADERBOARD;
					wl_menu[wl_current_menu]->hover_element = -1;
					wl_reset_particles(0);
				}
				else if(wl_game.player[0].profile > 0 && wl_option[WL_OPTION_INTERNET] == WL_INTERNET_ASK && wl_game.player[0].word_list_count > 0)
				{
					wl_state = WL_STATE_GAME_DONE;
					wl_select_menu(WL_MENU_UPLOAD_ASK);
				}
				else
				{
					wl_current_menu = WL_MENU_RETRY;
					wl_state = WL_STATE_GAME_DONE;
				}
				break;
			}
		}
	}
}

void wl_game_tally_render(void)
{
	wl_game_render();
	switch(wl_game.mode)
	{
		case WL_GAME_MODE_PARTY:
		{
			break;
		}
	}
}
