#ifndef WL_LEVEL_H
#define WL_LEVEL_H

#define WL_LEVEL_MAX_SHAPES 16
#define WL_LEVEL_LOAD_NORMAL 0
#define WL_LEVEL_LOAD_INTRO  1
#define WL_LEVEL_LOAD_MUSIC  2
#define WL_LEVEL_LOAD_FLAG_LOWRES 1

typedef struct
{
	
	float x, y, width, height;
	float target_width, target_height;

} WL_LEVEL_SHAPE;

typedef struct
{

	char name[256];
	int number; // number of the level (start with 1)
	T3F_ANIMATION * bg_animation;
	ALLEGRO_BITMAP * shape_image;
//	ALLEGRO_BITMAP * shape[WL_LEVEL_MAX_SHAPES];
	WL_LEVEL_SHAPE shape[WL_LEVEL_MAX_SHAPES];
	int shapes;
	bool shapes_used;
	ALLEGRO_COLOR color;
	float vz, va;
	
	float z, a, cx, cy, ox, oy;
	
	/* music info */
	char music_artist[64];
	char music_title[64];

} WL_LEVEL;

int wl_get_level_slot(int level);
bool wl_load_level_shapes(WL_LEVEL * lp, int flags);
void wl_free_level_shapes(WL_LEVEL * lp);
bool wl_load_level(WL_LEVEL * lp, int level, int mode, bool load_music, int flags);
void wl_free_level(WL_LEVEL * lp);

#endif
