#ifndef WL_MENU_PROC_H
#define WL_MENU_PROC_H

extern int wl_selected_profile;

/* setup menu */
int wl_menu_proc_setup_auto(void * data, int i, void * p);
int wl_menu_proc_setup_manual(void * data, int i, void * p);

/* main menu */
int wl_menu_proc_main_game(void * data, int i, void * p);
int wl_menu_proc_main_options(void * data, int i, void * p);
int wl_menu_proc_main_credits(void * data, int i, void * p);
int wl_menu_proc_main_privacy(void * data, int i, void * p);
int wl_menu_proc_main_quit(void * data, int i, void * p);
int wl_menu_proc_main_quit_yes(void * data, int i, void * p);
int wl_menu_proc_main_quit_no(void * data, int i, void * p);

/* game menu */
int wl_menu_proc_game_play(void * data, int i, void * p);
int wl_menu_proc_game_profiles(void * data, int i, void * p);
int wl_menu_proc_game_leaderboards(void * data, int i, void * p);
int wl_menu_proc_game_back(void * data, int i, void * p);

/* players menu */
int wl_menu_proc_game_players_single_player(void * data, int i, void * p);
int wl_menu_proc_game_players_multiplayer(void * data, int i, void * p);
int wl_menu_proc_game_players_back(void * data, int i, void * p);

/* multiplayer menu */
int wl_menu_proc_game_multiplayer_party(void * data, int i, void * p);
int wl_menu_proc_game_multiplayer_social(void * data, int i, void * p);
int wl_menu_proc_game_multiplayer_back(void * data, int i, void * p);

/* play menu */
void wl_create_play_menu(void);
int wl_menu_proc_play_profile(void * data, int i, void * p);
int wl_menu_proc_play_new(void * data, int i, void * p);
int wl_menu_proc_play_cancel(void * data, int i, void * p);

/* play select menu */
void wl_create_play_select_menu(void);
int wl_menu_proc_play_select_level(void * data, int i, void * p);
int wl_menu_proc_play_select_cancel(void * data, int i, void * p);
int wl_menu_proc_play_select_level_toggle_page(void * data, int i, void * p);

/* new player menu */
int wl_menu_proc_play_new_ok(void * data, int i, void * p);
int wl_menu_proc_play_new_cancel(void * data, int i, void * p);

/* play mode menu */
int wl_menu_proc_play_mode_story(void * data, int i, void * p);
int wl_menu_proc_play_mode_casual(void * data, int i, void * p);
int wl_menu_proc_play_mode_puzzle(void * data, int i, void * p);
int wl_menu_proc_play_mode_back(void * data, int i, void * p);

/* party play menu */
void wl_create_party_play_menu(void);
int wl_menu_proc_party_play_profile(void * data, int i, void * p);
int wl_menu_proc_party_play_add(void * data, int i, void * p);
int wl_menu_proc_party_play_ok(void * data, int i, void * p);
int wl_menu_proc_party_play_cancel(void * data, int i, void * p);

/* options menu */
void wl_create_options_menu(char * title, char * done_text);

/* profiles menu */
void wl_create_profiles_menu(void);
int wl_menu_proc_profiles_view(void * data, int i, void * p);
int wl_menu_proc_profiles_back(void * data, int i, void * p);

/* profile menu */
void wl_create_profile_menu(int profile);
int wl_menu_proc_profile_high_scores(void * data, int i, void * p);
int wl_menu_proc_profile_high_scores_back(void * data, int i, void * p);
int wl_menu_proc_profile_stats(void * data, int i, void * p);
int wl_menu_proc_profile_stats_back(void * data, int i, void * p);
int wl_menu_proc_profile_awards(void * data, int i, void * p);
bool wl_menu_upload_helper(void);
int wl_menu_proc_profile_upload(void * data, int i, void * p);
int wl_menu_proc_profile_back(void * data, int i, void * p);
int wl_menu_proc_profile_unlock(void * data, int i, void * p);
int wl_menu_proc_profile_unlock_yes(void * data, int i, void * p);
int wl_menu_proc_profile_unlock_no(void * data, int i, void * p);
int wl_menu_proc_profile_delete(void * data, int i, void * p);
int wl_menu_proc_profile_delete_yes(void * data, int i, void * p);
int wl_menu_proc_profile_delete_no(void * data, int i, void * p);

/* awards menu */
void wl_create_awards_menu(int profile);
int wl_menu_proc_awards_back(void * data, int i, void * p);

/* leaderboards */
bool wl_create_leaderboard_load_menu(int mode, int type);
bool wl_create_leaderboard_menu(int mode, int type);
int wl_menu_proc_leaderboards_story(void * data, int i, void * p);
int wl_menu_proc_leaderboards_casual(void * data, int i, void * p);
int wl_menu_proc_leaderboards_puzzle(void * data, int i, void * p);
int wl_menu_proc_leaderboards_best_word(void * data, int i, void * p);
int wl_menu_proc_leaderboards_back(void * data, int i, void * p);
int wl_menu_proc_leaderboards_done(void * data, int i, void * p);

/* game over */
int wl_menu_proc_game_over_retry(void * data, int i, void * p);
int wl_menu_proc_game_over_give_up(void * data, int i, void * p);

/* demo over */
int wl_menu_proc_demo_over_yes(void * data, int i, void * p);
int wl_menu_proc_demo_over_no(void * data, int i, void * p);

/* pause */
int wl_menu_proc_game_paused_continue(void * data, int i, void * p);
int wl_menu_proc_game_paused_exit(void * data, int i, void * p);
int wl_menu_proc_game_paused_quit(void * data, int i, void * p);

/* game end */
int wl_menu_proc_game_retry(void * data, int i, void * p);
int wl_menu_proc_game_quit(void * data, int i, void * p);

/* tutorial */
int wl_menu_proc_tutorial_skip_yes(void * data, int i, void * p);
int wl_menu_proc_tutorial_skip_no(void * data, int i, void * p);

int wl_menu_proc_overlay_menu(void * data, int i, void * p);
int wl_menu_proc_tally_overlay_done(void * data, int i, void * p);
void wl_create_play_mode_menu(void);
void wl_create_name_entry_menu(void);

int wl_menu_proc_upload_retry(void * data, int i, void * p);
int wl_menu_proc_upload_cancel(void * data, int i, void * p);

int wl_menu_proc_download_retry(void * data, int i, void * p);
int wl_menu_proc_download_cancel(void * data, int i, void * p);

int wl_menu_proc_overlay_fast_forward(void * data, int i, void * p);
int wl_menu_proc_overlay_next_track(void * data, int i, void * p);
int wl_menu_proc_overlay_previous_track(void * data, int i, void * p);

int wl_menu_proc_upload_yes(void * data, int i, void * p);
int wl_menu_proc_upload_no(void * data, int i, void * p);

#endif
