#ifndef WL_MESSAGE_H
#define WL_MESSAGE_H

#include "t3f/t3f.h"

#define WL_MAX_MESSAGES 16

#define WL_MESSAGE_TYPE_SCROLLER 0
#define WL_MESSAGE_TYPE_POPUP    1
#define WL_MESSAGE_TYPE_FLOAT_UP 2
#define WL_MESSAGE_TYPE_FLOAT_UP_2 3

typedef struct
{

	int type;
	char text[64];
	float x, y, z;
	float vx, vy, vz;
	int tick;
	void * dp;
	int state;
	int flags;
	
} WL_MESSAGE;

typedef struct
{

	WL_MESSAGE message[WL_MAX_MESSAGES];
	int messages;

} WL_MESSAGES;

void wl_add_message(WL_MESSAGES * mp, int type, char * text, void * dp, int flags);
void wl_message_logic(WL_MESSAGES * mp, bool multi);
void wl_render_messages(WL_MESSAGES * mp, bool multi);

#endif
