#ifndef WL_MUSIC_QUEUE_H
#define WL_MUSIC_QUEUE_H

#include "data.h"

#define WL_MUSIC_QUEUE_MAX_SIZE            8

#define WL_MUSIC_QUEUE_STATE_OFF           0
#define WL_MUSIC_QUEUE_STATE_PLAYING       1
#define WL_MUSIC_QUEUE_STATE_TRANSITIONING 2

#define WL_MUSIC_FADE_SPEED (1.0 / WL_LEVEL_FADE_FRAMES)

void wl_clear_music_queue(void);
bool wl_play_music(const char * fn);
bool wl_queue_music(const char * fn);
void wl_finish_current_song(void);
void wl_process_music_queue(void);
int wl_get_music_queue_state(void);
void wl_set_music_fade_speed(float speed);

#endif
