#ifndef WL_PARTICLE_H
#define WL_PARTICLE_H

#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "defines.h"

#define WL_PARTICLE_TYPE_FLASH 0
#define WL_PARTICLE_TYPE_GLASS 1
#define WL_PARTICLE_TYPE_SHARD 2
#define WL_PARTICLE_TYPE_MFLASH 3
#define WL_PARTICLE_TYPE_ICE    4
#define WL_PARTICLE_TYPE_STEAM  5

typedef struct
{

	int type;
	float x, y, z;
	float vx, vy, vz;
	float s;
	T3F_ANIMATION * animation;
	ALLEGRO_COLOR color;
	int start_life, life;
	bool active;
	int flags;

} WL_PARTICLE;

extern WL_PARTICLE wl_particle[2][WL_MAX_PARTICLES];
extern int wl_current_particle[2];

/* individual particle functions */
void wl_initialize_particle(WL_PARTICLE * pp, int type, T3F_ANIMATION * ap, ALLEGRO_COLOR color, float x, float y, float z, float s, int life, int flags);
void wl_process_particle(WL_PARTICLE * pp);
void wl_render_particle(WL_PARTICLE * pp);

/* particle array functions */
void wl_reset_particles(int list);
int wl_add_particle(int list, int type, T3F_ANIMATION * ap, ALLEGRO_COLOR color, float x, float y, float z, float s, int life, int flags);
void wl_process_particles(int list);
void wl_render_particles(int list, int type);

#endif
