#include "t3f/t3f.h"
#include "text.h"
#include "data.h"

static const char * wl_privacy_text =
	"Information We Collect:\n\n"
	"We collect only enough information to process your request. With regards to this "
	"software, that entails storing any scores you submit to our leaderboards (includes your "
	"profile name, score, and top word information).\n\n"
	"What We Do with Your Information:\n\n"
	"Your leaderboard data is accessible to everyone, so it is advisable to not put "
	"personal information you don't want to share in your screen name.";

void wl_privacy_logic(void)
{
	bool touched = false;
	int i;
	
	wl_title_word_logic();

	/* store touch input in local variables */
	for(i = 0; i < T3F_MAX_TOUCHES; i++)
	{
		if(t3f_touch[i].active)
		{
			touched = true;
			break;
		}
	}
	if(t3f_key[ALLEGRO_KEY_ESCAPE] || t3f_key[ALLEGRO_KEY_ENTER])
	{
		touched = true;
		t3f_key[ALLEGRO_KEY_ESCAPE] = 0;
		t3f_key[ALLEGRO_KEY_ENTER] = 0;
	}
	if(touched)
	{
		wl_reset_particles(0);
		wl_state = WL_STATE_TITLE;
		wl_mouse_clicked = true;
	}
}

void wl_privacy_render(void)
{
	al_clear_to_color(WL_TITLE_BG_COLOR);
	al_hold_bitmap_drawing(true);
	wl_title_word_render(wl_font[WL_FONT_16], 0.125);
	al_hold_bitmap_drawing(false);
	wl_draw_text_box(wl_font[WL_FONT_16], al_map_rgba_f(0.85, 0.85, 0.85, 0.85), al_map_rgba_f(0.0, 0.0, 0.0, 1.0), 32, 240, 640 - 64, 0, wl_privacy_text);
}
