#ifndef WL_PROFILE_H
#define WL_PROFILE_H

#include "t3f/t3f.h"

#define WL_MAX_PROFILES 32

#define WL_PROFILE_FLAG_UPLOAD_STORY   1
#define WL_PROFILE_FLAG_UPLOAD_CASUAL  2
#define WL_PROFILE_FLAG_UPLOAD_PUZZLE  4
#define WL_PROFILE_FLAG_UPLOAD_BEST    8
#define WL_PROFILE_FLAG_UPLOAD_BEST_C 16
#define WL_PROFILE_FLAG_UPLOAD_BEST_P 32
#define WL_PROFILE_FLAG_TUTORIAL_BASIC 64
#define WL_PROFILE_FLAG_TUTORIAL_STORY 128
#define WL_PROFILE_FLAG_TUTORIAL_CASUAL 256
#define WL_PROFILE_FLAG_TUTORIAL_PUZZLE 512
#define WL_PROFILE_FLAG_TUTORIAL_GURU (4096 * 2)
#define WL_PROFILE_FLAG_UPLOAD_GURU  1024
#define WL_PROFILE_FLAG_UPLOAD_BEST_G 2048
#define WL_PROFILE_FLAG_UNLOCKED      4096

/* awards flags */
#define WL_PROFILE_AWARD_WIN           1
#define WL_PROFILE_AWARD_MARATHON      2
#define WL_PROFILE_AWARD_HUNDRED       4
#define WL_PROFILE_AWARD_DEDICATION    8
#define WL_PROFILE_AWARD_STRIDE       16
#define WL_PROFILE_AWARD_QUICKIE      32
#define WL_PROFILE_AWARD_LOSER        64
#define WL_PROFILE_AWARD_ALL_CLEAR   128

/* secret awards */
#define WL_PROFILE_AWARD_BIG_FAN     256
#define WL_PROFILE_AWARD_FOUL        512

#define WL_PROFILE_MAX_HIGH_SCORES    64

typedef struct
{
	
	char name[256];
	int * word;
	unsigned long word_size;
	unsigned long words;
	unsigned long time;
	unsigned long moves;
	unsigned long undos;
	unsigned long wrongs;
	unsigned long progress;
	int games;
	int high_score[WL_PROFILE_MAX_HIGH_SCORES];
	int best_word[WL_PROFILE_MAX_HIGH_SCORES];
	int awards;
	int flags;

} WL_PROFILE;

typedef struct
{
	
	WL_PROFILE entry[WL_MAX_PROFILES];
	int entries;
	
} WL_PROFILES;

void wl_clear_profile(WL_PROFILE * pp);
WL_PROFILES * wl_create_profiles(void);
void wl_destroy_profiles(WL_PROFILES * pp);

WL_PROFILES * wl_load_profiles(const char * fn);
void wl_save_profiles(WL_PROFILES * pp, const char * fn);

/* expand the profile's list of guessed words */
bool wl_expand_profile(WL_PROFILES * pp, int entry, int amount);

void wl_delete_profile(WL_PROFILES * pp, int entry);

#endif
