#ifndef WL_SHAPE_H
#define WL_SHAPE_H

#include "t3f/t3f.h"
#include "defines.h"
#include "level.h"

typedef struct
{
	
	ALLEGRO_VERTEX v;
	int flags;
	
} WL_VERTEX;

typedef struct
{
	
	ALLEGRO_VERTEX vertex[WL_MAX_VERTICES];
	int vertices;
//	ALLEGRO_BITMAP * bp;
	ALLEGRO_BITMAP ** parent_bp;
	float ox, oy, oz;
	float vx, vy;
	float slope;
	int flags;
	
} WL_SHAPE;

void wl_generate_shape(WL_SHAPE * sp, WL_LEVEL_SHAPE * lsp, ALLEGRO_BITMAP ** parent_bp, float x, float y, float z, float slope);
void wl_connect_shape(WL_SHAPE * sp1, WL_SHAPE * sp2, WL_LEVEL_SHAPE * lsp, ALLEGRO_BITMAP ** parent_bp);
void wl_process_shape(WL_SHAPE * sp);
void wl_draw_shape(WL_SHAPE * sp, ALLEGRO_COLOR color, int flags);

void wl_cache_shape(int list, WL_SHAPE * sp);
void wl_draw_cached_shapes(int list, ALLEGRO_COLOR color);
void wl_clear_cached_shapes(int list);

#endif
