#ifndef WL_SPRITE_H
#define WL_SPRITE_H

#include "t3f/t3f.h"
#include "t3f/collision.h"
#include "defines.h"

typedef struct
{
	
	int type;
	int state;
	float x, y, z, a;
	float vx, vy, vz, va;
	float cy; // how far the center of the sprite is from the top of the bitmap
	int timer;
	T3F_COLLISION_OBJECT * collider;
	int tick;
	float ftick;
	bool active;
	int flags;
	
} WL_SPRITE;

/* use these pointers as a z-buffer, do actual drawing with these after sorting */
typedef struct
{
	
	WL_SPRITE * sprite[WL_MAX_SPRITES];
	int sprites;
	
} WL_SPRITE_LIST;

void wl_sprite_logic(WL_SPRITE * sp);
void wl_sprite_shadow_render(WL_SPRITE * sp);
void wl_sprite_render(WL_SPRITE * sp);
void wl_sprite_list_sort(WL_SPRITE_LIST * lp);

#endif
