#ifndef WL_TITLE_H
#define WL_TITLE_H

/* menu defines */
#define WL_MAX_MENUS               64
#define WL_MENU_MAIN                0
#define WL_MENU_PLAY                1
#define WL_MENU_NEW_PROFILE         2
#define WL_MENU_PROFILES            3
#define WL_MENU_PROFILE             4
#define WL_MENU_AWARDS              5
#define WL_MENU_PLAY_SELECT         6
#define WL_MENU_PLAY_MODE           7
#define WL_MENU_LEADERBOARD         8
#define WL_MENU_LEADERBOARDS        9
#define WL_MENU_GAME_OVER          10
#define WL_MENU_GAME_PAUSED        11
#define WL_MENU_OPTIONS            12
#define WL_MENU_GAME_EXIT          13
#define WL_MENU_QUIT               14
#define WL_MENU_RETRY              15
#define WL_MENU_GAME_PAUSED_2      16
#define WL_MENU_TUTORIAL           17
#define WL_MENU_PROFILE_SCORES     18
#define WL_MENU_PROFILE_STATS      19
#define WL_MENU_PROFILE_DELETE     20
#define WL_MENU_GAME_OVERLAY       21
#define WL_MENU_UPLOAD_FAILED      23
#define WL_MENU_DOWNLOAD_FAILED    24
#define WL_MENU_MUSIC_OVERLAY      25
#define WL_MENU_PROFILE_UNLOCK     26
#define WL_MENU_DEMO_OVER          27
#define WL_MENU_GAME               28
#define WL_MENU_UPLOAD_ASK         29
#define WL_MENU_PLAYERS            30
#define WL_MENU_MULTIPLAYER        31
#define WL_MENU_PARTY_PLAY         32
#define WL_MENU_EMPTY              63

#define WL_MAX_TITLE_WORDS         64

#define WL_TITLE_MENU_TOP         120
#define WL_TITLE_MENU_BOTTOM      480
#define WL_TITLE_LOGO_Y            64
#define WL_TITLE_COPYRIGHT_Y (WL_TITLE_LOGO_Y + 56)

#define WL_TITLE_BG_COLOR al_map_rgba_f(0.125, 0.125, 0.375, 1.0)

typedef struct
{

	int word;
	float x, y, a;
	float vx, vy, va;
	int time;
	int flags;

} WL_TITLE_WORD;

typedef struct
{

	ALLEGRO_BITMAP * bp;
	float x, y;
	float vx, vy;

} WL_TITLE_TILE;

void wl_select_menu(int menu);
void wl_title_init(void);
void wl_title_exit(void);
void wl_title_process_menu(void);
void wl_title_logic(void);
void wl_title_render_menu(void);
void wl_title_render(void);
void wl_title_exit_logic(void);
void wl_title_exit_render(void);
void wl_title_to_game_logic(void);
void wl_title_to_game_render(void);
void wl_title_credits_logic(void);
void wl_title_credits_render(void);
void wl_title_word_logic(void);
void wl_title_word_render(ALLEGRO_FONT * fp, float strength);

#endif
