#include "t3f/t3f.h"
#include "modules/cinema.h"
#include "modules/data.h"
#include "modules/leaderboards.h"
#include "ui/menu_leaderboards.h"
#include "instance.h"
#include "game_sprite.h"
#include "game_level.h"

void wl_game_over_logic(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	
	wl_process_cinema(instance->cinema, data);
	
	if(instance->cinema->tick >= instance->cinema->length)
	{
		wl_title_process_menu(instance->current_menu, data);
	}
}

void wl_game_over_wait_logic(void * data)
{
	wl_game_over_logic(data);
}

void wl_game_over_render(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	wl_render_cinema(instance->cinema, data);
	if(instance->cinema->tick >= instance->cinema->length)
	{
		wl_title_render_menu(data);
	}
}

void wl_game_over_wait_render(void * data)
{
	wl_game_over_render(data);
}

void wl_game_done_logic(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	
	if(instance->game.mode >= WL_GAME_MODE_STORY)
	{
		wl_process_particle_list(instance->particle_list[0]);
		wl_title_process_menu(instance->current_menu, data);
		wl_title_word_logic(data);
	}
	else
	{
		/* game logic */
		wl_process_particle_list(instance->particle_list[1]);
		wl_clear_board_flags(data);
		wl_game_sprite_logic(&instance->game, data);
		wl_board_logic(data);
		wl_game_player_logic(data);
		wl_game_level_bg_logic(data);
		
		wl_message_logic(&instance->game_messages, false);
		wl_message_logic(&instance->word_messages, true);
		
		wl_process_particle_list(instance->particle_list[0]);
		wl_title_process_menu(instance->current_menu, data);
	}
}

void wl_game_done_render(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	if(instance->game.mode >= WL_GAME_MODE_STORY)
	{
		wl_title_render(data);
	}
	else
	{
		wl_game_render(data);
		al_hold_bitmap_drawing(false);
		al_draw_filled_rectangle(0.0, 0.0, WL_VIRTUAL_DISPLAY_WIDTH, WL_VIRTUAL_DISPLAY_HEIGHT, al_map_rgba_f(0.0, 0.0, 0.0, 0.5));
		al_hold_bitmap_drawing(true);
		wl_title_render_menu(data);
		al_hold_bitmap_drawing(false);
	}
}
