#ifndef WL_CHARACTER_H
#define WL_CHARACTER_H

#include "t3f/t3f.h"

#define WL_CHARACTER_MAX_ANIMATIONS   9
#define WL_CHARACTER_ANIMATION_NORMAL 0
#define WL_CHARACTER_ANIMATION_HAPPY  1
#define WL_CHARACTER_ANIMATION_SAD    2
#define WL_CHARACTER_ANIMATION_HURT   3
#define WL_CHARACTER_ANIMATION_UP     4
#define WL_CHARACTER_ANIMATION_DOWN   5
#define WL_CHARACTER_ANIMATION_LEFT   6
#define WL_CHARACTER_ANIMATION_RIGHT  7
#define WL_CHARACTER_ANIMATION_SHADOW 8

typedef struct
{

  T3F_ANIMATION * animation[WL_CHARACTER_MAX_ANIMATIONS];
  char * name;

} WL_CHARACTER;

WL_CHARACTER * wl_load_character(const char * fn, float scale);
void wl_destroy_character(WL_CHARACTER * cp);
bool wl_add_character_to_atlas(WL_CHARACTER * cp, T3F_ATLAS * ap);

#endif
