#ifndef WL_DICTIONARY_H
#define WL_DICTIONARY_H

typedef struct
{
	
	char * data;
	int rarity;
	bool censored;
	
} WL_WORD;

typedef struct
{
	
	char * file_data;
	int file_pos;
	WL_WORD * word;
	int words;
	
	int offsets[26];
	
} WL_DICTIONARY;

void wl_sort_dictionary(WL_DICTIONARY * dp);
void wl_trim_dictionary(WL_DICTIONARY * dp);
WL_DICTIONARY * wl_load_dictionary(const char * fn);
bool wl_save_dictionary(WL_DICTIONARY * dp, const char * fn);
void wl_destroy_dictionary(WL_DICTIONARY * dp);
int wl_word_in_dictionary(WL_DICTIONARY * dp, const char * wp);
void wl_apply_censorship_to_dictionary(WL_DICTIONARY * dp, WL_DICTIONARY * censorship_dp);

#endif
