#ifndef WL_LEVEL_H
#define WL_LEVEL_H

#define WL_LEVEL_MAX_SHAPES 16

#define WL_LEVEL_LOAD_FLAG_MUSIC_ONLY (1 << 0)
#define WL_LEVEL_LOAD_FLAG_THREADED   (1 << 1)

typedef struct
{
	
	float x, y, width, height;
	float target_width, target_height;

} WL_LEVEL_SHAPE;

typedef struct
{

	char * name;
	char * music_path;
	int number; // number of the level (start with 1)
	T3F_ANIMATION * bg_animation;
	T3F_BITMAP * shape_image;
//	ALLEGRO_BITMAP * shape[WL_LEVEL_MAX_SHAPES];
	WL_LEVEL_SHAPE shape[WL_LEVEL_MAX_SHAPES];
	int shapes;
	bool shapes_used;
	ALLEGRO_COLOR color;
	float vz, va;
	
	float z, a, cx, cy, ox, oy;
	
	/* music info */
	char * artist;
	char * music_artist;
	char * music_title;

} WL_LEVEL;

bool wl_load_level_shapes(WL_LEVEL * lp, ALLEGRO_CONFIG * scp, ALLEGRO_PATH * path, int flags);
void wl_free_level_shapes(WL_LEVEL * lp);
void wl_play_level_music(WL_LEVEL * lp, void * data);
WL_LEVEL * wl_load_level(int level, int flags, void * data);
void wl_destroy_level(WL_LEVEL * lp);

void wl_update_level(WL_LEVEL * lp);

#endif
