#ifndef WL_LEVEL_LIST_H
#define WL_LEVEL_LIST_H

#include "profile.h"

typedef struct
{
	
	char * path;
	char * name;
	char * story_name;
	char * unlock_name;
	char * character;
	char * intro_fn;
	char * ending_fn;
	char * pause_fn;
	char * continue_fn;
	char * quit_fn;
	char * game_over_fn;

	/* story data */
	int story;
	int slot;
	int base_range;
	float life_decrease;
	int hazard_delay;
	int powerup_health;
	int powerup_guru;
	int powerup_sneaker;
	int laser_chances;
	int bomb_chances;
	int spike_chances;

} WL_LEVEL_LIST_ENTRY;

typedef struct
{

	char * name;
	char * unlock_name;
	char * character;
	int start_level;
	int end_level;
	char * intro_fn;
	char * ending_fn;
	char * pause_fn;
	char * continue_fn;
	char * quit_fn;
	char * game_over_fn;

	/* gameplay settings */
	int base_range;
	int powerup_health;
	int powerup_guru;
	int powerup_sneaker;

} WL_LEVEL_LIST_STORY_DATA;

typedef struct
{

	WL_LEVEL_LIST_ENTRY * entry;
	int entry_max;
	int entry_count;

	WL_LEVEL_LIST_STORY_DATA * story;
	int story_max;
	int story_count;

	/* list of unlocked levels */
	bool * unlocked_story;
	int * unlocked_index;
	int unlocked_count;

}	WL_LEVEL_LIST;

WL_LEVEL_LIST * wl_create_level_list(int max);
void wl_destroy_level_list(WL_LEVEL_LIST * lp);

int wl_count_installed_levels(void);
bool wl_catalog_installed_levels(WL_LEVEL_LIST * lp);

void wl_update_unlocked_level_list(WL_LEVEL_LIST * lp, WL_PROFILE * pp);

#endif
