#ifndef WL_PARTICLE_H
#define WL_PARTICLE_H

#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "defines.h"

#define WL_PARTICLE_TYPE_FLASH 0
#define WL_PARTICLE_TYPE_GLASS 1
#define WL_PARTICLE_TYPE_SHARD 2
#define WL_PARTICLE_TYPE_MFLASH 3
#define WL_PARTICLE_TYPE_ICE    4
#define WL_PARTICLE_TYPE_STEAM  5

typedef struct
{

	int type;
	float x, y, z;
	float vx, vy, vz;
	float s;
	T3F_ANIMATION * animation;
	ALLEGRO_COLOR color;
	int start_life, life;
	bool active;
	int flags;

} WL_PARTICLE;

typedef struct
{

	WL_PARTICLE * particle;
	int particles;
	int current_particle;

} WL_PARTICLE_LIST;

/* individual particle functions */
void wl_initialize_particle(WL_PARTICLE * pp, int type, T3F_ANIMATION * ap, ALLEGRO_COLOR color, float x, float y, float z, float s, int life, int flags);
void wl_process_particle(WL_PARTICLE * pp);
void wl_render_particle(WL_PARTICLE * pp);

/* particle array functions */
WL_PARTICLE_LIST * wl_create_particle_list(int max);
void wl_destroy_particle_list(WL_PARTICLE_LIST * lp);
void wl_reset_particle_list(WL_PARTICLE_LIST * lp);
int wl_add_particle(WL_PARTICLE_LIST * lp, int type, T3F_ANIMATION * ap, ALLEGRO_COLOR color, float x, float y, float z, float s, int life, int flags);
void wl_process_particle_list(WL_PARTICLE_LIST * lp);
void wl_render_particle_list(WL_PARTICLE_LIST * lp, int type);

#endif
