#ifndef WL_PROFILE_H
#define WL_PROFILE_H

#include "t3f/t3f.h"

#define WL_MAX_PROFILES 32

#define WL_PROFILE_FLAG_TUTORIAL_BASIC  (1 << 0)
#define WL_PROFILE_FLAG_TUTORIAL_STORY  (1 << 1)
#define WL_PROFILE_FLAG_TUTORIAL_CASUAL (1 << 2)
#define WL_PROFILE_FLAG_TUTORIAL_PUZZLE (1 << 3)
#define WL_PROFILE_FLAG_TUTORIAL_GURU   (1 << 4)
#define WL_PROFILE_FLAG_UNLOCKED        (1 << 5)
#define WL_PROFILE_FLAG_TUTORIAL_SKIP   (1 << 6)

#define WL_PROFILE_MAX_HIGH_SCORES    64
#define WL_PROFILE_MAX_STORIES        16

typedef struct
{
	
	char name[256];
	int * word;
	unsigned long word_size;
	unsigned long words;
	unsigned long time;
	unsigned long moves;
	unsigned long undos;
	unsigned long wrongs;
	unsigned long progress[WL_PROFILE_MAX_STORIES];
	int games;
	int high_score[WL_PROFILE_MAX_HIGH_SCORES];
	int high_score_extra[WL_PROFILE_MAX_HIGH_SCORES];
	char high_score_upload[WL_PROFILE_MAX_HIGH_SCORES];
	int best_word[WL_PROFILE_MAX_HIGH_SCORES];
	int best_word_extra[WL_PROFILE_MAX_HIGH_SCORES];
	char best_word_upload[WL_PROFILE_MAX_HIGH_SCORES];
	int flags;

} WL_PROFILE;

WL_PROFILE * wl_create_profile(void);
void wl_destroy_profile(WL_PROFILE * pp);

WL_PROFILE * wl_load_legacy_profiles(const char * fn);
WL_PROFILE * wl_load_profile(const char * fn);
void wl_save_profile(WL_PROFILE * pp, const char * fn);

/* expand the profile's list of guessed words */
bool wl_expand_profile(WL_PROFILE * pp, int amount);

#endif
