#ifndef WL_TILE_H
#define WL_TILE_H

#define WL_TILE_MAX_BITMAPS 16

#define WL_TILE_CONNECT_NONE   (1 << 0)
#define WL_TILE_CONNECT_H      (1 << 1)
#define WL_TILE_CONNECT_V      (1 << 2)
#define WL_TILE_CONNECT_VH     (1 << 3)

#define WL_TILE_STANDALONE    0
#define WL_TILE_TOP_LEFT      1
#define WL_TILE_TOP           2
#define WL_TILE_TOP_RIGHT     3
#define WL_TILE_LEFT          4
#define WL_TILE_CENTER        5
#define WL_TILE_RIGHT         6
#define WL_TILE_BOTTOM_LEFT   7
#define WL_TILE_BOTTOM        8
#define WL_TILE_BOTTOM_RIGHT  9
#define WL_TILE_H_LEFT       10
#define WL_TILE_H_CENTER     11
#define WL_TILE_H_RIGHT      12
#define WL_TILE_V_TOP        13
#define WL_TILE_V_CENTER     14
#define WL_TILE_V_BOTTOM     15

typedef struct
{

  T3F_BITMAP * bitmap[WL_TILE_MAX_BITMAPS];
  T3F_ATLAS * atlas;
  float width;
  float height;

} WL_TILE;

WL_TILE * wl_load_tile(const char * fn, int flags);
void wl_destroy_tile(WL_TILE * tp);

void wl_draw_single_tile(WL_TILE * tp, int tile, ALLEGRO_COLOR color, float x, float y, float z, int flags);
void wl_draw_tile(WL_TILE * tp, ALLEGRO_COLOR color, float x, float y, float z, int w, int h, int flags);
void wl_draw_scaled_tile(WL_TILE * fp, ALLEGRO_COLOR color, float x, float y, float z, float width, float height, int w, int h, int flags);

#endif
