#include "t3f/t3f.h"
#include "modules/leaderboards.h"
#include "instance.h"
#include "menu_play.h"
#include "menu_leaderboards.h"
#include "menu_profile.h"

/* players menu */
int wl_menu_proc_game_players_single_player(void * data, int i, void * p)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	instance->game.players = 1;
	instance->multiplayer = false;
	wl_create_play_mode_menu(data);
	wl_select_menu(WL_MENU_DYNAMIC, data);
	return 1;
}

/* game menu */
int wl_menu_proc_game_play(void * data, int i, void * p)
{
	return wl_menu_proc_game_players_single_player(data, i, p);
}

int wl_menu_proc_game_leaderboards(void * data, int i, void * p)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	instance->leaderboard_mode = 0;
	instance->leaderboard_type = 0;
	instance->leaderboard_style = 0;
	_wl_unload_leaderboard(instance);
	wl_create_leaderboard_menu(instance->leaderboard_mode, instance->leaderboard_type, data);
	wl_download_scores(data);
	wl_select_menu(WL_MENU_DYNAMIC, data);
	instance->state = WL_STATE_LEADERBOARDS;
	return 1;
}

int wl_menu_proc_game_back(void * data, int i, void * p)
{
	wl_select_menu(WL_MENU_MAIN, data);
	return 1;
}

T3F_GUI * wl_create_game_menu(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	T3F_GUI * menu;
	int pos = 0;

	menu = t3f_create_gui(0, 0);
	if(!menu)
	{
		return NULL;
	}
	t3f_add_gui_text_element(menu, wl_menu_proc_game_play, "PLAY", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "Play the Game");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_profiles_view, "PROFILE", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE);
	t3f_describe_last_gui_element(menu, "View Profile");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_game_leaderboards, "LEADERBOARDS", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "View Leaderboards");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_game_back, "BACK", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_center_gui(menu, WL_TITLE_MENU_TOP, WL_TITLE_MENU_BOTTOM);

  return menu;
}
