#include "t3f/t3f.h"
#include "instance.h"
#include "menu_options.h"
#include "menu_dialog.h"

int wl_menu_proc_main_game(void * data, int i, void * p)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	wl_update_unlocked_level_list(instance->level_list, instance->profile);
	wl_select_menu(WL_MENU_GAME, data);
	return 1;
}

int wl_menu_proc_main_options(void * data, int i, void * p)
{
	wl_create_options_menu("OPTIONS", "BACK", data);
	wl_select_menu(WL_MENU_OPTIONS, data);
	return 1;
}

int wl_menu_proc_main_credits(void * data, int i, void * p)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	wl_credits_initialize(&instance->credits, 0, data);
	instance->state = WL_STATE_TITLE_CREDITS;
	instance->menu[instance->current_menu]->hover_element = -1;
	wl_reset_particle_list(instance->particle_list[0]);
	return 1;
}

int wl_menu_proc_main_privacy(void * data, int i, void * p)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	instance->state = WL_STATE_PRIVACY;
	instance->menu[instance->current_menu]->hover_element = -1;
	wl_reset_particle_list(instance->particle_list[0]);
	return 1;
}

int wl_menu_proc_main_purchase(void * data, int i, void * p)
{
	return wl_menu_proc_demo_over_yes(data, i, p);
}

int wl_menu_proc_main_quit(void * data, int i, void * p)
{
	wl_select_menu(WL_MENU_QUIT, data);
	return 1;
}

T3F_GUI * wl_create_main_menu(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
  T3F_GUI * menu;
  int pos = 0;

	menu = t3f_create_gui(0, 0);
	if(!menu)
	{
		return NULL;
	}
	t3f_add_gui_text_element(menu, wl_menu_proc_main_game, "GAME", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "Play the Game");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_main_options, "OPTIONS", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "Change Game Options");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_main_credits, "CREDITS", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "See Who Made the Game");
	pos++;
	t3f_add_gui_text_element(menu, wl_menu_proc_main_privacy, "PRIVACY", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_describe_last_gui_element(menu, "See Privacy Information");
	pos++;
	if(instance->demo)
	{
		t3f_add_gui_text_element(menu, wl_menu_proc_main_purchase, "PURCHASE", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
		t3f_describe_last_gui_element(menu, "Get the Full Version of the Game");
		pos++;
	}
	t3f_add_gui_text_element(menu, wl_menu_proc_main_quit, "QUIT", (void **)&instance->font[WL_FONT_24], WL_VIRTUAL_DISPLAY_WIDTH / 2, 48 * pos, al_map_rgba_f(0.0, 0.0, 0.0, 1.0), T3F_GUI_ELEMENT_CENTRE | T3F_GUI_ELEMENT_COPY);
	t3f_center_gui(menu, WL_TITLE_MENU_TOP, WL_TITLE_MENU_BOTTOM);

  return menu;
}
