#include "t3f/t3f.h"
#include "modules/text.h"
#include "modules/data.h"
#include "instance.h"

static const char * wl_privacy_text =
	"Information We Collect:\n\n"
	"We collect only enough information to process your request. With regards to this "
	"software, that entails storing any scores you submit to our leaderboards (includes your "
	"profile name, score, and top word information).\n\n"
	"What We Do with Your Information:\n\n"
	"Your leaderboard data is accessible to everyone, so it is advisable to not put "
	"personal information you don't want to share in your screen name.";

void wl_privacy_logic(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	
	_wl_animate_title_logo(instance);
	wl_title_word_logic(data);

	if(instance->input_state.action.pressed || instance->input_state.pause.pressed)
	{
		wl_reset_particle_list(instance->particle_list[0]);
		t3f_clear_touch_state();
		instance->state = WL_STATE_TITLE;
	}
}

void wl_privacy_render(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;

	_wl_draw_title_bg(data);
	wl_draw_text_box(instance->box_nine_patch, instance->font[WL_FONT_16], al_map_rgba_f(0.85, 0.85, 0.85, 0.85), al_map_rgba_f(0.0, 0.0, 0.0, 1.0), t3f_current_view->left + 32, 240, t3f_current_view->right - t3f_current_view->left - 64, WL_TEXT_BOX_FLAG_CENTER_Y, instance->tick, wl_privacy_text);
}
