#ifndef WL_TITLE_H
#define WL_TITLE_H

/* menu defines */
#define WL_MAX_MENUS               64

/* title menus */
#define WL_MENU_MAIN                0
#define WL_MENU_PLAY                1
#define WL_MENU_OPTIONS             2
#define WL_MENU_PROFILE_UNLOCK      3
#define WL_MENU_GAME                4

/* overlay menus */
#define WL_MENU_GAME_OVER           5
#define WL_MENU_GAME_PAUSED         6
#define WL_MENU_SCENE_PAUSED        7
#define WL_MENU_GAME_EXIT           8
#define WL_MENU_QUIT                9
#define WL_MENU_RETRY              10
#define WL_MENU_TUTORIAL           11
#define WL_MENU_GAME_OVERLAY       12
#define WL_MENU_MUSIC_OVERLAY      13
#define WL_MENU_DEMO_OVER          14
#define WL_MENU_GAME_STORY_PAUSED  15
#define WL_MENU_GAME_MODE_MAIN     16

#define WL_MENU_DYNAMIC            17
#define WL_MENU_EMPTY              63

#define WL_MAX_TITLE_WORDS         64

#define WL_TITLE_MENU_TOP         120
#define WL_TITLE_MENU_BOTTOM      WL_VIRTUAL_DISPLAY_HEIGHT
#define WL_TITLE_LOGO_Y            64
#define WL_TITLE_COPYRIGHT_Y (WL_TITLE_LOGO_Y + 56)

#define WL_TITLE_BG_COLOR al_map_rgba_f(0.125, 0.125, 0.375, 1.0)

typedef struct
{

	int word;
	float x, y, a;
	float vx, vy, va;
	int time;
	int flags;

} WL_TITLE_WORD;

typedef struct
{

	T3F_BITMAP * bp;
	float x, y, z;
	float vx, vy, vz;
	bool gravity;

} WL_TITLE_TILE;

void wl_select_menu(int menu, void * data);
bool wl_title_load_data(void * data, bool pause_timer);
void wl_title_free_data(void * data);
bool wl_title_init(void * data);
void wl_title_exit(void * data);
void wl_title_process_menu(int menu, void * data);
void wl_title_logic(void * data);
void wl_title_render_menu(void * data);
void wl_title_render(void * data);
void wl_title_exit_logic(void * data);
void wl_title_exit_render(void * data);
void wl_title_to_game_logic(void * data);
void wl_title_to_game_render(void * data);
void wl_title_credits_logic(void * data);
void wl_title_credits_render(void * data);
void wl_title_word_logic(void * data);
void wl_title_word_render(T3F_FONT * fp, float strength, void * data);
void _wl_draw_title_bg(void * data);
void _wl_animate_title_logo(void * data);

#endif
